;*****WINMAIN*******************************************************************
WMSTRUC STRUC
 msg MSG {}      ;message structure ****ALWAYS KEEP MSG STRUCTURE AT BEGINNING
WMSTRUC ENDS

MAIN:
 XOR EBP,EBP     ;handy constant zero
 SUB ESP,WMSTRUC ;make local space

 INVOKE GetModuleHandleA,EBP

 MOV ESI,EAX     ;now ESI=module handle

;*****CLASS REGISTRATION********************************************************

 IF TRUE ;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 INVOKE LoadIcon,EBP,IDI_APPLICATION      ;EBP=0
 ELSE ;<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><
 INVOKE LoadIcon,ESI,IDI_APPLICATION      ;ESI=hInst
 ENDIF ;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 MOV EBX,EAX                              ;EBX=EAX=hIcon
 PUSH EAX

APPNAME EQU 'SYSMETRICS'
 IF TRUE ;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 RPUSHIT EBP,LTEXT(szAppName,APPNAME,0)
 ELSE ;<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><
 RPUSHIT TEXT(szAppName,APPNAME,0),@ szAppName
 ENDIF ;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

 IF TRUE ;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 PUSH COLOR_WINDOW+1                      ;for window background color
 ELSEIF FALSE ;<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><
 INVOKE CreateSolidBrush,WHITE_BRUSH	  ;
 PUSH EAX
 ELSE ;<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><
 INVOKE GetStockObject,EBP                ;EBP=0=WHITE_BRUSH
 PUSH EAX
 ENDIF ;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

 INVOKE LoadCursor,EBP,IDC_ARROW
 RPUSHIT EAX                              ;cursor handle

 PUSH EBX                                 ;hIcon

 S1=CS_HREDRAW OR CS_VREDRAW
 RPUSHIT WNDCLASSEX,S1,@ WINCALLBACK,EBP,EBP,ESI     ;ESI=hInst
 INVOKE RegisterClassEx,ESP

IF DBUG
 TEST EAX,EAX
  .IF ZERO?
   INVOKE MessageBox,ESI,TEXT('Class registration failed.',0),EBP,EBP ;EBP=0
   JMP EXIT
 .ENDIF
ENDIF

; ADD ESP,10*DWORD                        ;balance stack from WNDCLASS
 ADD ESP,12*DWORD                        ;balance stack from WNDCLASSEX

;*****END OF CLASS REGISTRATION*************************************************
;*****WINDOW CREATION***********************************************************

 MOV ECX,CW_USEDEFAULT
 S1=WS_OVERLAPPEDWINDOW OR WS_VSCROLL OR WS_HSCROLL

 INVOKE CreateWindowExA,EBP,@ szAppName,@ szAppName,\
                        S1,ECX,ECX,ECX,ECX,EBP,EBP,ESI,EBP ;EBP=0
IF DBUG
 TEST EAX,EAX
 .IF ZERO?
   INVOKE MessageBox,ESI,TEXT('Main CreateWindow call error',0),EBP,EBP ;EBP=0
   JMP EXIT
 .ENDIF
ENDIF

 MOV [hwnd],EAX        ;window handle 
 MOV ESI,EAX           ;now ESI=hwnd=window handle

;*****END OF WINDOW CREATION****************************************************

 INVOKE ShowWindow,ESI,SW_SHOWNORMAL

 INVOKE UpdateWindow,ESI

IF DBUG
 TEST EAX,EAX
 .IF ZERO?
   INVOKE MessageBox,ESI,TEXT('UpdateWindow call error',0),EBP,EBP ;EBP=0
   JMP EXIT
 .ENDIF
ENDIF

 MOV EBX,ESP  ;EBX=&msg

 .WHILE TRUE  ;beginning of message loop
   INVOKE GetMessageA,EBX,EBP,EBP,EBP ;
   TEST EAX,EAX

   IF DBUG
    JS GMERR ;jump out on GetMessage error
   ELSE
    JS EXIT  ;jump out on GetMessage error
   ENDIF

   .BREAK .IF ZERO? ;jump out on WM_QUIT message

   INVOKE TranslateMessage,EBX ;EBX=&msg
   INVOKE DispatchMessageA,EBX ;EBX=&msg
 .ENDW                         ;repeat message loop

 MOV EAX,[ESP.MSG.wParam]

EXIT:
 ADD ESP,WMSTRUC               ;recover local space

 INVOKE ExitProcess,EAX

IF DBUG
GMERR:                         ;display error message via message box & jmp to EXIT
 INVOKE MessageBox,ESI,TEXT('GetMessage call error',0),EBP,EBP ;EBP=0
 JMP EXIT
ENDIF

SCROLLINFODUMP:

SINFODMP$ STRUC
ADR1$     = $
 DWORD 4 DUP (?)               ;save EAX,EBX,ECX,EDX
ADR2$     = $
 RETURN   DWORD ?
ADR3$     = $
 SINFOADR DWORD ?
ADR4$     = $
SINFODMP$ ENDS

SFD$ EQU ESP.SINFODMP$
SIF  EQU EBX.SCROLLINFO

 .DATA
szBuffer BYTE 120 DUP (?)

 .CODE
 RPUSHIT EAX,EBX,ECX,EDX

 MOV EBX,[SFD$.SINFOADR]

 INVOKE wsprintf,@ szBuffer,TEXT('cbSize = %lu',CRLF,'fmask = %8X',CRLF,'nMin = %lu',CRLF,'nMax = %lu',CRLF,'nPage = %lu',CRLF,'nPos = %lu',0),\
                 [SIF.cbSize],[SIF.fMask],[SIF.nMin],[SIF.nMax],[SIF.nPage],[SIF.nPos]
 INVOKE MessageBox,ESI,@ szBuffer,TEXT('SINFO DUMP',0),0

 POPIT EAX,EBX,ECX,EDX
 RET ADR4$-ADR3$
 


;*****END OF WINMAIN************************************************************
